# coding: utf-8

"""
    HashiCorp Vault API

    HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.

    The version of the OpenAPI document: 1.15.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class AliCloudWriteRoleRequest(BaseModel):
    """
    AliCloudWriteRoleRequest
    """ # noqa: E501
    inline_policies: Optional[StrictStr] = Field(default=None, description="JSON of policies to be dynamically applied to users of this role.")
    max_ttl: Optional[StrictStr] = Field(default=None, description="The maximum allowed lifetime of tokens issued using this role.")
    remote_policies: Optional[List[StrictStr]] = Field(default=None, description="The name and type of each remote policy to be applied. Example: \"name:AliyunRDSReadOnlyAccess,type:System\".")
    role_arn: Optional[StrictStr] = Field(default=None, description="ARN of the role to be assumed. If provided, inline_policies and remote_policies should be blank. At creation time, this role must have configured trusted actors, and the access key and secret that will be used to assume the role (in /config) must qualify as a trusted actor.")
    ttl: Optional[StrictStr] = Field(default=None, description="Duration in seconds after which the issued token should expire. Defaults to 0, in which case the value will fallback to the system/mount defaults.")
    __properties: ClassVar[List[str]] = ["inline_policies", "max_ttl", "remote_policies", "role_arn", "ttl"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AliCloudWriteRoleRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AliCloudWriteRoleRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "inline_policies": obj.get("inline_policies"),
            "max_ttl": obj.get("max_ttl"),
            "remote_policies": obj.get("remote_policies"),
            "role_arn": obj.get("role_arn"),
            "ttl": obj.get("ttl")
        })
        return _obj


