# coding: utf-8

"""
    HashiCorp Vault API

    HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.

    The version of the OpenAPI document: 1.15.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class AppRoleLookUpSecretIdResponse(BaseModel):
    """
    AppRoleLookUpSecretIdResponse
    """ # noqa: E501
    cidr_list: Optional[List[StrictStr]] = Field(default=None, description="List of CIDR blocks enforcing secret IDs to be used from specific set of IP addresses. If 'bound_cidr_list' is set on the role, then the list of CIDR blocks listed here should be a subset of the CIDR blocks listed on the role.")
    creation_time: Optional[datetime] = None
    expiration_time: Optional[datetime] = None
    last_updated_time: Optional[datetime] = None
    metadata: Optional[Dict[str, Any]] = None
    secret_id_accessor: Optional[StrictStr] = Field(default=None, description="Accessor of the secret ID")
    secret_id_num_uses: Optional[StrictInt] = Field(default=None, description="Number of times a secret ID can access the role, after which the secret ID will expire.")
    secret_id_ttl: Optional[StrictStr] = Field(default=None, description="Duration in seconds after which the issued secret ID expires.")
    token_bound_cidrs: Optional[List[StrictStr]] = Field(default=None, description="List of CIDR blocks. If set, specifies the blocks of IP addresses which can use the returned token. Should be a subset of the token CIDR blocks listed on the role, if any.")
    __properties: ClassVar[List[str]] = ["cidr_list", "creation_time", "expiration_time", "last_updated_time", "metadata", "secret_id_accessor", "secret_id_num_uses", "secret_id_ttl", "token_bound_cidrs"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AppRoleLookUpSecretIdResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AppRoleLookUpSecretIdResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "cidr_list": obj.get("cidr_list"),
            "creation_time": obj.get("creation_time"),
            "expiration_time": obj.get("expiration_time"),
            "last_updated_time": obj.get("last_updated_time"),
            "metadata": obj.get("metadata"),
            "secret_id_accessor": obj.get("secret_id_accessor"),
            "secret_id_num_uses": obj.get("secret_id_num_uses"),
            "secret_id_ttl": obj.get("secret_id_ttl"),
            "token_bound_cidrs": obj.get("token_bound_cidrs")
        })
        return _obj


