# coding: utf-8

"""
    HashiCorp Vault API

    HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.

    The version of the OpenAPI document: 1.15.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class AuthReadTuningInformationResponse(BaseModel):
    """
    AuthReadTuningInformationResponse
    """ # noqa: E501
    allowed_managed_keys: Optional[List[StrictStr]] = None
    allowed_response_headers: Optional[List[StrictStr]] = None
    audit_non_hmac_request_keys: Optional[List[StrictStr]] = None
    audit_non_hmac_response_keys: Optional[List[StrictStr]] = None
    default_lease_ttl: Optional[StrictInt] = None
    description: Optional[StrictStr] = None
    external_entropy_access: Optional[StrictBool] = None
    force_no_cache: Optional[StrictBool] = None
    listing_visibility: Optional[StrictStr] = None
    max_lease_ttl: Optional[StrictInt] = None
    options: Optional[Dict[str, Any]] = None
    passthrough_request_headers: Optional[List[StrictStr]] = None
    plugin_version: Optional[StrictStr] = None
    token_type: Optional[StrictStr] = None
    user_lockout_counter_reset_duration: Optional[StrictInt] = None
    user_lockout_disable: Optional[StrictBool] = None
    user_lockout_duration: Optional[StrictInt] = None
    user_lockout_threshold: Optional[StrictInt] = None
    __properties: ClassVar[List[str]] = ["allowed_managed_keys", "allowed_response_headers", "audit_non_hmac_request_keys", "audit_non_hmac_response_keys", "default_lease_ttl", "description", "external_entropy_access", "force_no_cache", "listing_visibility", "max_lease_ttl", "options", "passthrough_request_headers", "plugin_version", "token_type", "user_lockout_counter_reset_duration", "user_lockout_disable", "user_lockout_duration", "user_lockout_threshold"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AuthReadTuningInformationResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AuthReadTuningInformationResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "allowed_managed_keys": obj.get("allowed_managed_keys"),
            "allowed_response_headers": obj.get("allowed_response_headers"),
            "audit_non_hmac_request_keys": obj.get("audit_non_hmac_request_keys"),
            "audit_non_hmac_response_keys": obj.get("audit_non_hmac_response_keys"),
            "default_lease_ttl": obj.get("default_lease_ttl"),
            "description": obj.get("description"),
            "external_entropy_access": obj.get("external_entropy_access"),
            "force_no_cache": obj.get("force_no_cache"),
            "listing_visibility": obj.get("listing_visibility"),
            "max_lease_ttl": obj.get("max_lease_ttl"),
            "options": obj.get("options"),
            "passthrough_request_headers": obj.get("passthrough_request_headers"),
            "plugin_version": obj.get("plugin_version"),
            "token_type": obj.get("token_type"),
            "user_lockout_counter_reset_duration": obj.get("user_lockout_counter_reset_duration"),
            "user_lockout_disable": obj.get("user_lockout_disable"),
            "user_lockout_duration": obj.get("user_lockout_duration"),
            "user_lockout_threshold": obj.get("user_lockout_threshold")
        })
        return _obj


