# coding: utf-8

"""
    HashiCorp Vault API

    HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.

    The version of the OpenAPI document: 1.15.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class AzureConfigureRequest(BaseModel):
    """
    AzureConfigureRequest
    """ # noqa: E501
    client_id: Optional[StrictStr] = Field(default=None, description="The OAuth2 client id to connect to Azure. This value can also be provided with the AZURE_CLIENT_ID environment variable.")
    client_secret: Optional[StrictStr] = Field(default=None, description="The OAuth2 client secret to connect to Azure. This value can also be provided with the AZURE_CLIENT_SECRET environment variable.")
    environment: Optional[StrictStr] = Field(default=None, description="The Azure environment name. If not provided, AzurePublicCloud is used. This value can also be provided with the AZURE_ENVIRONMENT environment variable.")
    password_policy: Optional[StrictStr] = Field(default=None, description="Name of the password policy to use to generate passwords for dynamic credentials.")
    root_password_ttl: Optional[StrictStr] = Field(default='15768000000000000', description="The TTL of the root password in Azure. This can be either a number of seconds or a time formatted duration (ex: 24h, 48ds)")
    subscription_id: Optional[StrictStr] = Field(default=None, description="The subscription id for the Azure Active Directory. This value can also be provided with the AZURE_SUBSCRIPTION_ID environment variable.")
    tenant_id: Optional[StrictStr] = Field(default=None, description="The tenant id for the Azure Active Directory. This value can also be provided with the AZURE_TENANT_ID environment variable.")
    __properties: ClassVar[List[str]] = ["client_id", "client_secret", "environment", "password_policy", "root_password_ttl", "subscription_id", "tenant_id"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AzureConfigureRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AzureConfigureRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "client_id": obj.get("client_id"),
            "client_secret": obj.get("client_secret"),
            "environment": obj.get("environment"),
            "password_policy": obj.get("password_policy"),
            "root_password_ttl": obj.get("root_password_ttl") if obj.get("root_password_ttl") is not None else '15768000000000000',
            "subscription_id": obj.get("subscription_id"),
            "tenant_id": obj.get("tenant_id")
        })
        return _obj


