# coding: utf-8

"""
    HashiCorp Vault API

    HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.

    The version of the OpenAPI document: 1.15.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class CertConfigureRequest(BaseModel):
    """
    CertConfigureRequest
    """ # noqa: E501
    disable_binding: Optional[StrictBool] = Field(default=False, description="If set, during renewal, skips the matching of presented client identity with the client identity used during login. Defaults to false.")
    enable_identity_alias_metadata: Optional[StrictBool] = Field(default=False, description="If set, metadata of the certificate including the metadata corresponding to allowed_metadata_extensions will be stored in the alias. Defaults to false.")
    ocsp_cache_size: Optional[StrictInt] = Field(default=100, description="The size of the in memory OCSP response cache, shared by all configured certs")
    __properties: ClassVar[List[str]] = ["disable_binding", "enable_identity_alias_metadata", "ocsp_cache_size"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CertConfigureRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CertConfigureRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "disable_binding": obj.get("disable_binding") if obj.get("disable_binding") is not None else False,
            "enable_identity_alias_metadata": obj.get("enable_identity_alias_metadata") if obj.get("enable_identity_alias_metadata") is not None else False,
            "ocsp_cache_size": obj.get("ocsp_cache_size") if obj.get("ocsp_cache_size") is not None else 100
        })
        return _obj


