# coding: utf-8

"""
    HashiCorp Vault API

    HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.

    The version of the OpenAPI document: 1.15.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class GoogleCloudConfigureAuthRequest(BaseModel):
    """
    GoogleCloudConfigureAuthRequest
    """ # noqa: E501
    credentials: Optional[StrictStr] = Field(default=None, description="Google credentials JSON that Vault will use to verify users against GCP APIs. If not specified, will use application default credentials")
    custom_endpoint: Optional[Dict[str, Any]] = Field(default=None, description="Specifies overrides for various Google API Service Endpoints used in requests.")
    gce_alias: Optional[StrictStr] = Field(default='role_id', description="Indicates what value to use when generating an alias for GCE authentications.")
    gce_metadata: Optional[List[StrictStr]] = Field(default=None, description="The metadata to include on the aliases and audit logs generated by this plugin. When set to 'default', includes: instance_creation_timestamp, instance_id, instance_name, project_id, project_number, role, service_account_id, service_account_email, zone. Not editing this field means the 'default' fields are included. Explicitly setting this field to empty overrides the 'default' and means no metadata will be included. If not using 'default', explicit fields must be sent like: 'field1,field2'.")
    google_certs_endpoint: Optional[StrictStr] = Field(default=None, description="Deprecated. This field does nothing and be removed in a future release")
    iam_alias: Optional[StrictStr] = Field(default='role_id', description="Indicates what value to use when generating an alias for IAM authentications.")
    iam_metadata: Optional[List[StrictStr]] = Field(default=None, description="The metadata to include on the aliases and audit logs generated by this plugin. When set to 'default', includes: project_id, role, service_account_id, service_account_email. Not editing this field means the 'default' fields are included. Explicitly setting this field to empty overrides the 'default' and means no metadata will be included. If not using 'default', explicit fields must be sent like: 'field1,field2'.")
    __properties: ClassVar[List[str]] = ["credentials", "custom_endpoint", "gce_alias", "gce_metadata", "google_certs_endpoint", "iam_alias", "iam_metadata"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GoogleCloudConfigureAuthRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GoogleCloudConfigureAuthRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "credentials": obj.get("credentials"),
            "custom_endpoint": obj.get("custom_endpoint"),
            "gce_alias": obj.get("gce_alias") if obj.get("gce_alias") is not None else 'role_id',
            "gce_metadata": obj.get("gce_metadata"),
            "google_certs_endpoint": obj.get("google_certs_endpoint"),
            "iam_alias": obj.get("iam_alias") if obj.get("iam_alias") is not None else 'role_id',
            "iam_metadata": obj.get("iam_metadata")
        })
        return _obj


