# coding: utf-8

"""
    HashiCorp Vault API

    HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.

    The version of the OpenAPI document: 1.15.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class LeasesReadLeaseResponse(BaseModel):
    """
    LeasesReadLeaseResponse
    """ # noqa: E501
    expire_time: Optional[datetime] = Field(default=None, description="Optional lease expiry time")
    id: Optional[StrictStr] = Field(default=None, description="Lease id")
    issue_time: Optional[datetime] = Field(default=None, description="Timestamp for the lease's issue time")
    last_renewal: Optional[datetime] = Field(default=None, description="Optional Timestamp of the last time the lease was renewed")
    renewable: Optional[StrictBool] = Field(default=None, description="True if the lease is able to be renewed")
    ttl: Optional[StrictInt] = Field(default=None, description="Time to Live set for the lease, returns 0 if unset")
    __properties: ClassVar[List[str]] = ["expire_time", "id", "issue_time", "last_renewal", "renewable", "ttl"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of LeasesReadLeaseResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of LeasesReadLeaseResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "expire_time": obj.get("expire_time"),
            "id": obj.get("id"),
            "issue_time": obj.get("issue_time"),
            "last_renewal": obj.get("last_renewal"),
            "renewable": obj.get("renewable"),
            "ttl": obj.get("ttl")
        })
        return _obj


