# coding: utf-8

"""
    HashiCorp Vault API

    HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.

    The version of the OpenAPI document: 1.15.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class MongoDbAtlasWriteRoleRequest(BaseModel):
    """
    MongoDbAtlasWriteRoleRequest
    """ # noqa: E501
    cidr_blocks: Optional[List[StrictStr]] = Field(default=None, description="Access list entry in CIDR notation to be added for the API key. Optional for organization and project keys.")
    ip_addresses: Optional[List[StrictStr]] = Field(default=None, description="IP address to be added to the access list for the API key. Optional for organization and project keys.")
    max_ttl: Optional[StrictStr] = Field(default=None, description="The maximum allowed lifetime of credentials issued using this role.")
    organization_id: Optional[StrictStr] = Field(default=None, description="Organization ID required for an organization API key")
    project_id: Optional[StrictStr] = Field(default=None, description="Project ID the project API key belongs to.")
    project_roles: Optional[List[StrictStr]] = Field(default=None, description="Roles assigned when an organization API Key is assigned to a project API key")
    roles: List[StrictStr] = Field(description="List of roles that the API Key should be granted. A minimum of one role must be provided. Any roles provided must be valid for the assigned Project, required for organization and project keys.")
    ttl: Optional[StrictStr] = Field(default=None, description="Duration in seconds after which the issued credential should expire. Defaults to 0, in which case the value will fallback to the system/mount defaults.")
    __properties: ClassVar[List[str]] = ["cidr_blocks", "ip_addresses", "max_ttl", "organization_id", "project_id", "project_roles", "roles", "ttl"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of MongoDbAtlasWriteRoleRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of MongoDbAtlasWriteRoleRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "cidr_blocks": obj.get("cidr_blocks"),
            "ip_addresses": obj.get("ip_addresses"),
            "max_ttl": obj.get("max_ttl"),
            "organization_id": obj.get("organization_id"),
            "project_id": obj.get("project_id"),
            "project_roles": obj.get("project_roles"),
            "roles": obj.get("roles"),
            "ttl": obj.get("ttl")
        })
        return _obj


