# coding: utf-8

"""
    HashiCorp Vault API

    HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.

    The version of the OpenAPI document: 1.15.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class PkiIssuerResignCrlsRequest(BaseModel):
    """
    PkiIssuerResignCrlsRequest
    """ # noqa: E501
    crl_number: Optional[StrictInt] = Field(default=None, description="The sequence number to be written within the CRL Number extension.")
    crls: Optional[List[StrictStr]] = Field(default=None, description="A list of PEM encoded CRLs to combine, originally signed by the requested issuer.")
    delta_crl_base_number: Optional[StrictInt] = Field(default=-1, description="Using a zero or greater value specifies the base CRL revision number to encode within a Delta CRL indicator extension, otherwise the extension will not be added.")
    format: Optional[StrictStr] = Field(default='pem', description="The format of the combined CRL, can be \"pem\" or \"der\". If \"der\", the value will be base64 encoded. Defaults to \"pem\".")
    next_update: Optional[StrictStr] = Field(default='72h', description="The amount of time the generated CRL should be valid; defaults to 72 hours.")
    __properties: ClassVar[List[str]] = ["crl_number", "crls", "delta_crl_base_number", "format", "next_update"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PkiIssuerResignCrlsRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PkiIssuerResignCrlsRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "crl_number": obj.get("crl_number"),
            "crls": obj.get("crls"),
            "delta_crl_base_number": obj.get("delta_crl_base_number") if obj.get("delta_crl_base_number") is not None else -1,
            "format": obj.get("format") if obj.get("format") is not None else 'pem',
            "next_update": obj.get("next_update") if obj.get("next_update") is not None else '72h'
        })
        return _obj


