# coding: utf-8

"""
    HashiCorp Vault API

    HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.

    The version of the OpenAPI document: 1.15.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class PkiRootSignSelfIssuedRequest(BaseModel):
    """
    PkiRootSignSelfIssuedRequest
    """ # noqa: E501
    certificate: Optional[StrictStr] = Field(default=None, description="PEM-format self-issued certificate to be signed.")
    issuer_ref: Optional[StrictStr] = Field(default='default', description="Reference to a existing issuer; either \"default\" for the configured default issuer, an identifier or the name assigned to the issuer.")
    require_matching_certificate_algorithms: Optional[StrictBool] = Field(default=False, description="If true, require the public key algorithm of the signer to match that of the self issued certificate.")
    __properties: ClassVar[List[str]] = ["certificate", "issuer_ref", "require_matching_certificate_algorithms"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PkiRootSignSelfIssuedRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PkiRootSignSelfIssuedRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "certificate": obj.get("certificate"),
            "issuer_ref": obj.get("issuer_ref") if obj.get("issuer_ref") is not None else 'default',
            "require_matching_certificate_algorithms": obj.get("require_matching_certificate_algorithms") if obj.get("require_matching_certificate_algorithms") is not None else False
        })
        return _obj


