# coding: utf-8

"""
    HashiCorp Vault API

    HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.

    The version of the OpenAPI document: 1.15.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class RadiusConfigureRequest(BaseModel):
    """
    RadiusConfigureRequest
    """ # noqa: E501
    dial_timeout: Optional[StrictStr] = Field(default='10', description="Number of seconds before connect times out (default: 10)")
    host: Optional[StrictStr] = Field(default=None, description="RADIUS server host")
    nas_identifier: Optional[StrictStr] = Field(default='', description="RADIUS NAS Identifier field (optional)")
    nas_port: Optional[StrictInt] = Field(default=10, description="RADIUS NAS port field (default: 10)")
    port: Optional[StrictInt] = Field(default=1812, description="RADIUS server port (default: 1812)")
    read_timeout: Optional[StrictStr] = Field(default='10', description="Number of seconds before response times out (default: 10)")
    secret: Optional[StrictStr] = Field(default=None, description="Secret shared with the RADIUS server")
    token_bound_cidrs: Optional[List[StrictStr]] = Field(default=None, description="Comma separated string or JSON list of CIDR blocks. If set, specifies the blocks of IP addresses which are allowed to use the generated token.")
    token_explicit_max_ttl: Optional[StrictStr] = Field(default=None, description="If set, tokens created via this role carry an explicit maximum TTL. During renewal, the current maximum TTL values of the role and the mount are not checked for changes, and any updates to these values will have no effect on the token being renewed.")
    token_max_ttl: Optional[StrictStr] = Field(default=None, description="The maximum lifetime of the generated token")
    token_no_default_policy: Optional[StrictBool] = Field(default=None, description="If true, the 'default' policy will not automatically be added to generated tokens")
    token_num_uses: Optional[StrictInt] = Field(default=None, description="The maximum number of times a token may be used, a value of zero means unlimited")
    token_period: Optional[StrictStr] = Field(default=None, description="If set, tokens created via this role will have no max lifetime; instead, their renewal period will be fixed to this value. This takes an integer number of seconds, or a string duration (e.g. \"24h\").")
    token_policies: Optional[List[StrictStr]] = Field(default=None, description="Comma-separated list of policies. This will apply to all tokens generated by this auth method, in addition to any configured for specific users.")
    token_ttl: Optional[StrictStr] = Field(default=None, description="The initial ttl of the token to generate")
    token_type: Optional[StrictStr] = Field(default='default-service', description="The type of token to generate, service or batch")
    unregistered_user_policies: Optional[StrictStr] = Field(default='', description="Comma-separated list of policies to grant upon successful RADIUS authentication of an unregistered user (default: empty)")
    __properties: ClassVar[List[str]] = ["dial_timeout", "host", "nas_identifier", "nas_port", "port", "read_timeout", "secret", "token_bound_cidrs", "token_explicit_max_ttl", "token_max_ttl", "token_no_default_policy", "token_num_uses", "token_period", "token_policies", "token_ttl", "token_type", "unregistered_user_policies"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of RadiusConfigureRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of RadiusConfigureRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "dial_timeout": obj.get("dial_timeout") if obj.get("dial_timeout") is not None else '10',
            "host": obj.get("host"),
            "nas_identifier": obj.get("nas_identifier") if obj.get("nas_identifier") is not None else '',
            "nas_port": obj.get("nas_port") if obj.get("nas_port") is not None else 10,
            "port": obj.get("port") if obj.get("port") is not None else 1812,
            "read_timeout": obj.get("read_timeout") if obj.get("read_timeout") is not None else '10',
            "secret": obj.get("secret"),
            "token_bound_cidrs": obj.get("token_bound_cidrs"),
            "token_explicit_max_ttl": obj.get("token_explicit_max_ttl"),
            "token_max_ttl": obj.get("token_max_ttl"),
            "token_no_default_policy": obj.get("token_no_default_policy"),
            "token_num_uses": obj.get("token_num_uses"),
            "token_period": obj.get("token_period"),
            "token_policies": obj.get("token_policies"),
            "token_ttl": obj.get("token_ttl"),
            "token_type": obj.get("token_type") if obj.get("token_type") is not None else 'default-service',
            "unregistered_user_policies": obj.get("unregistered_user_policies") if obj.get("unregistered_user_policies") is not None else ''
        })
        return _obj


