# coding: utf-8

"""
    HashiCorp Vault API

    HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.

    The version of the OpenAPI document: 1.15.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class RootTokenGenerationInitializeResponse(BaseModel):
    """
    RootTokenGenerationInitializeResponse
    """ # noqa: E501
    complete: Optional[StrictBool] = None
    encoded_root_token: Optional[StrictStr] = None
    encoded_token: Optional[StrictStr] = None
    nonce: Optional[StrictStr] = None
    otp: Optional[StrictStr] = None
    otp_length: Optional[StrictInt] = None
    pgp_fingerprint: Optional[StrictStr] = None
    progress: Optional[StrictInt] = None
    required: Optional[StrictInt] = None
    started: Optional[StrictBool] = None
    __properties: ClassVar[List[str]] = ["complete", "encoded_root_token", "encoded_token", "nonce", "otp", "otp_length", "pgp_fingerprint", "progress", "required", "started"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of RootTokenGenerationInitializeResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of RootTokenGenerationInitializeResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "complete": obj.get("complete"),
            "encoded_root_token": obj.get("encoded_root_token"),
            "encoded_token": obj.get("encoded_token"),
            "nonce": obj.get("nonce"),
            "otp": obj.get("otp"),
            "otp_length": obj.get("otp_length"),
            "pgp_fingerprint": obj.get("pgp_fingerprint"),
            "progress": obj.get("progress"),
            "required": obj.get("required"),
            "started": obj.get("started")
        })
        return _obj


