# coding: utf-8

"""
    HashiCorp Vault API

    HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.

    The version of the OpenAPI document: 1.15.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class SshIssueCertificateRequest(BaseModel):
    """
    SshIssueCertificateRequest
    """ # noqa: E501
    cert_type: Optional[StrictStr] = Field(default='user', description="Type of certificate to be created; either \"user\" or \"host\".")
    critical_options: Optional[Dict[str, Any]] = Field(default=None, description="Critical options that the certificate should be signed for.")
    extensions: Optional[Dict[str, Any]] = Field(default=None, description="Extensions that the certificate should be signed for.")
    key_bits: Optional[StrictInt] = Field(default=0, description="Specifies the number of bits to use for the generated keys.")
    key_id: Optional[StrictStr] = Field(default=None, description="Key id that the created certificate should have. If not specified, the display name of the token will be used.")
    key_type: Optional[StrictStr] = Field(default='rsa', description="Specifies the desired key type; must be `rsa`, `ed25519` or `ec`")
    ttl: Optional[StrictStr] = Field(default=None, description="The requested Time To Live for the SSH certificate; sets the expiration date. If not specified the role default, backend default, or system default TTL is used, in that order. Cannot be later than the role max TTL.")
    valid_principals: Optional[StrictStr] = Field(default=None, description="Valid principals, either usernames or hostnames, that the certificate should be signed for.")
    __properties: ClassVar[List[str]] = ["cert_type", "critical_options", "extensions", "key_bits", "key_id", "key_type", "ttl", "valid_principals"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SshIssueCertificateRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SshIssueCertificateRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "cert_type": obj.get("cert_type") if obj.get("cert_type") is not None else 'user',
            "critical_options": obj.get("critical_options"),
            "extensions": obj.get("extensions"),
            "key_bits": obj.get("key_bits") if obj.get("key_bits") is not None else 0,
            "key_id": obj.get("key_id"),
            "key_type": obj.get("key_type") if obj.get("key_type") is not None else 'rsa',
            "ttl": obj.get("ttl"),
            "valid_principals": obj.get("valid_principals")
        })
        return _obj


